/*
	Descrição: Funcionalidades do projeto
    Autor: Adriano Angélico
	Data: 20/03/2015
	Versão: 1.0
*/

function HabilitaFuncoes() {
    

    // Fecha a janela ativa onde o botão fechar se apresenta
    $(".close-btn").on("click", function () {
        $(this).parent().fadeOut("fast");
        $(".sidebar-btn").next().fadeOut("fast");
        $(".sidebar-btn").removeClass("sidebar-btn-active");
        $(".mask-modal").fadeOut("fast");
    });

    // Menu de usuário logado //
    function userMenu() {
        var cls = "user-menu-active-btn";

        $(".user-menu, .user-menu > ul").on("click", function (e) {
            e.stopPropagation();
        });

        $(".user-menu").on("click", function () {
            if ($(".user-menu > ul").is(":hidden")) {
                $(".user-menu > button").addClass(cls);
                $(".user-menu > ul").fadeIn("fast");
                $(".user-menu .user-data .user-name").css({ "background-image": "url(../Content/DemandaTarefa/Images/sel-arrow-up.png)" });
            } else {
                $(".user-menu > button").removeClass(cls);
                $(".user-menu > ul").fadeOut("fast");
                $(".user-menu .user-data .user-name").css({ "background-image": "url(../Content/DemandaTarefa/Images/sel-arrow-down.png)" });
            }
        });

        $("body").on("click", function () {
            $(".user-menu > button").removeClass(cls);
            $(".user-menu > ul").fadeOut("fast");
        });
    }

    userMenu();

    // Menu da barra lateral
    function sidebarMenu() {
        $(".sidebar-btn").on("click", function () {
            var box = $(this).parent().next();
            var btn = $(this);

            if (box.is(":hidden")) {
                $(".sidebar-box-content").fadeOut("fast");
                $(".sidebar-btn").next().fadeOut("fast");
                box.fadeIn("fast");
                btn.next().fadeIn("fast");
                $(".sidebar-btn").removeClass("sidebar-btn-active")
                btn.addClass("sidebar-btn-active");
            } else {
                box.fadeOut("fast");
                btn.next().fadeOut("fast");
                btn.removeClass("sidebar-btn-active");
            }
        })
    }

    sidebarMenu();

    // Alterna entre as abas e filtros
    //$(".abas-grid li").on("click", function () {
    //    if ($(this).attr("id") == "abaTarefas") {
    //        var x = $("div[data-grid=grid-tarefas]");

    //        $(".ripple li").removeClass();
    //        $(this).addClass("abas-grid-active");

    //        // mostra a grid de tarefas
    //        $(".footer .wrap-grid").removeClass("show").addClass("hide");
    //        x.removeClass("hide").addClass("show");

    //        // habilita o botão do filtro de tarefas
    //        $("[data-filtro=filtro-demandas]").parent().removeClass("show").addClass("hide");
    //        $("[data-filtro=filtro-demandas]").removeClass("sidebar-btn-active");
    //        $("[data-filtro=filtro-tarefas]").parent().removeClass("hide").addClass("show");
    //        $(".sidebar-box-content").fadeOut("fast");
    //        $(".sidebar-btn").next().fadeOut("fast");
    //        $(".header-title").text("Sinótico de Chamados - Tarefas");
    //        $("#addDemandas").hide();
    //        $("#agdTarefas").show();
    //        $(".sb_demanda").fadeOut("fast");
    //    } else {
    //        var x = $("div[data-grid=grid-demandas]");

    //        $(".ripple li").removeClass();
    //        $(this).addClass("abas-grid-active");

    //        // mostra a grid de demandas
    //        $(".footer .wrap-grid").removeClass("show").addClass("hide");
    //        x.removeClass("hide").addClass("show");

    //        // habilita o botão de filtro de demandas
    //        $("[data-filtro=filtro-tarefas]").parent().removeClass("show").addClass("hide");
    //        $("[data-filtro=filtro-tarefas]").removeClass("sidebar-btn-active");
    //        $("[data-filtro=filtro-demandas]").parent().removeClass("hide").addClass("show");
    //        $(".sidebar-box-content").fadeOut("fast");
    //        $(".sidebar-btn").next().fadeOut("fast");
    //        $(".header-title").text("Sinótico de Chamados - Demandas");
    //        $("#agdTarefas").hide();
    //        $("#addDemandas").show();
    //        $(".sb_tarefa").fadeOut("fast");
    //    }
    //});

    // Redimensiona o footer
    /*$(".footer").resizable({
        alsoResize: ".slick-viewport, .wrap-grid, #myGrid",
        animate: false,
        minHeight: 171,
        handles: "n",
        stop: function (event, ui) {
            grid.resizeCanvas();

            var h = $(".footer").outerHeight();
            $(".sidebar, .content").css({"bottom" : +h + "px"});
        }
    });*/

    // Oculta ou mostra o footer
    $(".grid-title").toggle(
		function () {
		    $(".wrap-grid, .tabs-grid-footer").hide();
		    $(".footer").css({ "top": "auto", "height": "auto" });
		    $(".sidebar, .content").css({ "bottom": "20px" });
		}, function () {
		    $(".wrap-grid, .tabs-grid-footer").show();

		    // Ajusta a barra lateral de acordo com a altura da grid
		    var h = $("footer").outerHeight();
		    $(".sidebar, .content").css({ "bottom": +h + "px" });
		}
	);

    // Mostra as notificações de alarmes no canto direito da tela
    function notificacoes() {
        var h = $(".footer").outerHeight();
        $("#barra-alarmes").css({ "bottom": h });

        var t = setInterval(function () { listaAlarmes() }, 5000);

        var n = 0;

        var boxHeight = $("#barra-alarmes").outerHeight();

        function alturaBarra() {
            if ($(".lista-barra-alarmes").outerHeight() > boxHeight) {
                $("#barra-alarmes").css({ "overflow-y": "scroll" });
                $(".lista-barra-alarmes").css({ "position": "relative" });
            } else {
                $("#barra-alarmes").css({ "overflow-y": "hidden" });
                $(".lista-barra-alarmes").css({ "position": "absolute" });
            }
        }

        function listaAlarmes() {
            var box = $(".box-info-alarmes:first-child").clone();

            $(".lista-barra-alarmes").prepend(box);
            box.fadeIn("slow");

            alturaBarra();

            //n += 1;

            n = Math.floor(Math.random() * 15 + 1);

            if (n < 5) {
                $(box).children("[class^='icon-alert-']").removeClass().addClass("icon-alert-green");
                $(box).children("[class^='icon-alert-']").text(n);
            } else if (n > 10) {
                $(box).children("[class^='icon-alert-']").removeClass().addClass("icon-alert-yellow");
                $(box).children("[class^='icon-alert-']").text(n);
            } else {
                $(box).children("[class^='icon-alert-']").removeClass().addClass("icon-alert-red");
                $(box).children("[class^='icon-alert-']").text(n);
            }

            // $(".box-info-alarmes:first-child h1").text(n);

            $(".btn-fechar-box").on("click", function () {
                $(this).parent().fadeOut("fast");

                alturaBarra();
            });
        }

        setTimeout(function () {
            clearInterval(t);
        }, 51000);
    }

    // notificacoes();

    // Abre e fecha o mini-mapa da janela editar demandas
    $(".toggle-mapa").on("click", function () {
        $(".mini-mapa").slideToggle();
    });

    // Funções auxiliares
    //$("#addDemandas").on("click", function () {
    //$("#modalAdicionarDemandas, #modalAdicionarDemandas .big-modal").fadeIn("fast");
    //});

    $("#agdTarefas").on("click", function () {
        vm.Perspectiva.AgendamentoTarefa().RegiaoSelecionada(null);
        vm.Perspectiva.TarefasRemovidas([]);
        $(".barra-alarmeSucesso-modal").hide();
        $(".barra-alarme-modal").hide();


        $("#modalAgendarTarefas, #modalAgendarTarefas .big-modal").fadeIn("fast");
    });

    $(function () {
        $("#cpfCnpj").focus(function () {
            $(this).unmask();
            $(this).val($(this).val().replace(/\D/g, ""));
        }).click(function () {
            $(this).val($(this).val().replace(/\D/g, "")).unmask();
            $(this).unmask();
        }).blur(function () {
            if ($(this).val().length == 11) {
                $(this).mask("999.999.999-99");
            } else if ($(this).val().length == 14) {
                $(this).mask("99.999.999/9999-99");
            }
        });
    });

    //$(".close-alert-btn").on("click", function () {
    //    $(".barra-alarme-modal").fadeOut("fast");
    //});

    //$(".footerbar-grid").toggle(function () {
    //    $(this).parent().parent().css({ "bottom": "-202px" });
    //    $(".content").css({ "bottom": "43px" });
    //}, function () {
    //    $(this).parent().parent().css({ "bottom": "0" });
    //    $(".content").css({ "bottom": "245px" });
    //});
    //show/hide footer
    $(".footerbar-grid").toggle(function () {
        $(this).parent().parent().animate({
            bottom: "-202px",
            marginBottom: "0px"
        }, 500);
        $(".notificacao-evento").animate({
            marginTop: $(document).height() - $("footer").height() + 156 + "px"
        }, 500);
        $(".content").css({ "bottom": "43px" });
        $(".slick-columnpicker").fadeOut(250);
    }, function () {
        $(this).parent().parent().animate({
            bottom: "0",
            marginBottom: "23px"
        }, 500);
        $(".notificacao-evento").animate({
            marginTop: $(document).height() - $("footer").height() - 294 + "px"
        }, 500);
        $(".content").css({ "bottom": "245px" });
    });
    //arrow up/down
    $(function () {
        $(".footerbar-grid").click(function () {
            if ($(this).find('.abas-grid i').hasClass('icon-arrow-top')) {
                $(this).find('.abas-grid i').removeClass('icon-arrow-top');
                $(this).find('.abas-grid i').addClass('icon-icon-13');
                $(".sidebar-box-content").css("max-height", "646px");
            }
            else {
                $(this).find('.abas-grid i').removeClass('icon-icon-13');
                $(this).find('.abas-grid i').addClass('icon-arrow-top');
                $(".sidebar-box-content").css("max-height", "");
            }
        });
    });

    $(".reports li, #addDemandas, #agdTarefas").on("click", function (e) {
        e.stopPropagation();
    });

    $(".close-alert-btn").on("click", function () {
        $(this).parent().fadeOut();
    });
};

function SomenteNumero(e) {
    var tecla = (window.event) ? event.keyCode : e.which;
    if ((tecla > 47 && tecla < 58)) return true;
    else {
        if (tecla == 8 || tecla == 0) return true;
        else return false;
    }
};